<!-- SPDX-License-Identifier: CC-BY-4.0 -->
<!-- Copyright Contributors to the OpenColorIO Project. -->

March 9, 2020

Host: Michael Dolan

Rotating Secretary: Michael Dolan

Attendees:
  * [ ] Mark Boorer (_TSC_) - Industrial Light & Magic
  * [ ] Sean Cooper (_TSC_) - DNEG
  * [X] Michael Dolan (_TSC Chair_) - Epic Games
  * [X] Larry Gritz (_TSC_) - Sony Pictures Imageworks
  * [X] Patrick Hodoul (_TSC_) - Autodesk
  * [ ] John Mertic - Academy Software Foundation / Linux Foundation
  * [ ] Carl Rand (_TSC_) - Weta Digital
  * [X] Doug Walker (_TSC Chief Architect_) - Autodesk
  * [ ] Kevin Wheatley (_TSC_) - Framestore
  * [X] Bernard Lefebvre - Autodesk
  * [X] Mei Chu - Sony Pictures Imageworks
  * [X] Carol Payne - Netflix
  * [X] Robin Rowe

Apologies:
  * Kevin Wheatley

# **OCIO TSC Meeting Notes**

* Documentation
    - Need to determine future doc goals and implementation.
    - Doug: Autodesk team has looked at docs, finds reST and Sphinx to be 
      cumbersome to edit, particularly when trying to predict how embedded
      header docs will render.
    - Many header changes have been needed to get docs to generate cleanly.
    - Patrick: The doc build process is fragile, and not intuitive to setup
      on Windows, because of Sphinx' dependence on Python.
    - Doug: The PDF generation is problematic.
    - Larry: OIIO dropped PDF "book" after moving to RTD. RTD itself can 
      generate a PDF. It isn't as pretty, but works well enough, and the
      RTD online docs are most useful.
    - OIIO uses breathe to connect C++ doxygen docs to Sphinx, which works 
      well. Doxygen has made some improvements, and is worth considering.
      It may be compatible with reST now. Overall the ease of doc generation
      outweighs any inconvenience.
    - Doug: We should have some action steps to guide contributors. Rashil 
      stood up RTD quickly and could continue the work.
    - Patrick: We should set some guidelines based on our discussion to make
      the work more concrete.
    - Michael: Decoupling the doc build from the library build would be good
      first steps, and an opportunity to improve the system. 
    - **TODO**: Michael will discuss options with Rashil to see if he has 
      interest in furthering his work.
    - Doug: All of the docs need a bit of overhaul. For general docs, it 
      would be great to crowd source within the community. Perhaps a wiki?
    - Carol: Wiki is a great idea. There is a lot of knowledge in the 
      community to contribute. Talking to ACES about similar work and would 
      be happy to help investigate options.
    - **TODO**: Carol will report back on Wiki investigation.
    - Patrick: Thomas has a Wiki for colour-science. We could ask about his
      approach.
    - Doug: Is there any opinions about whether continuing to put docs in the 
      header files is the right approach?
    - Patrick: The downside is that the headers get a bit bloated, which could
      make it harder to read.
    - Michael: I like the docs in the header. It's a great overview of the 
      interface, and iterates with the code. I wouldn't mind seeing more docs 
      in OpenColorTypes.h, since some of the enum docs can be hard to find
      in the source.

* GSoC
    - Patrick: Students are actively investigating potential projects. Now is
      the time to help them and answer questions.
    - They must propose projects in the later half of March, with two weeks to 
      submit. We then have about a month to review applicants. Any guidance we
      can give should be a priority.
