<!-- SPDX-License-Identifier: CC-BY-4.0 -->
<!-- Copyright Contributors to the OpenColorIO Project. -->

March 23, 2020

Host: Doug Walker

Rotating Secretary: Doug Walker

Attendees:
  * [X] Mark Boorer (_TSC_) - Industrial Light & Magic
  * [X] Sean Cooper (_TSC_) - DNEG
  * [ ] Michael Dolan (_TSC Chair_) - Epic Games
  * [X] Larry Gritz (_TSC_) - Sony Pictures Imageworks
  * [X] Patrick Hodoul (_TSC_) - Autodesk
  * [ ] John Mertic - Academy Software Foundation / Linux Foundation
  * [ ] Carl Rand (_TSC_) - Weta Digital
  * [X] Doug Walker (_TSC Chief Architect_) - Autodesk
  * [X] Kevin Wheatley (_TSC_) - Framestore
  * [X] Mei Chu - Sony Pictures Imageworks
  * [X] Bernard Lefebvre - Autodesk
  * [X] Michael Min - Netflix
  * [X] Carol Payne - Netflix
  * [X] Rashil Gandhi - student

Apologies: Michael Dolan

# **OCIO TSC Meeting Notes**

* Google Summer of Code Proposal about Ffmpeg
    - Doug: Michael, Patrick, and I are working with Rashil Gandhi on his GSoC proposal
        which is to add OCIO support to Ffmpeg.  Do people think that is enough work
        for a 3 month, 40 hour/week summer project?
    - Mark, Kevin:  Probably.  Adding it as a video filter should be very do-able although
        trying to add it to the core may be a big task.  Also, keep in mind it is C, not C++,
        and the dev process is via patches to the email forum rather than GitHub PRs.
        Also, their community expects strict adherence to their communication style.
        It may take awhile to get the code approved, especially if it is to the core lib.
        They have their own fork of OpenEXR to allow access from straight C.
    - Larry: There is some inherent uncertainty in the amount of work but it should not 
        prevent moving forward with a proposal, we can suggest other tasks if it turns
        out to go faster than expected.
    - Rashil: (Via chat) For some reason my microphone isn't working. 
    - Rashil: I can probably work on making the versioned documentation too, if the FFmpeg 
        project is too small :)
    - Larry: We should reach out to the ffmpeg community to line up someone to advise.
    - Doug: Is there another OSS project that people would suggest Rashil work on that
        would be even better than Ffmpeg?  
        - Group: Ffmpeg is widely used at our studios today and we still think it would be
          a great project.
    - Carol: What other tools in Ffmpeg are needed, could EXR images be scaled and cropped?
    - Larry: We should solicit input from those at our studios that work with Ffmpeg to
        get input on the workflow and any gotchas.  (Mei, Mark, and Kevin all raised their
        hands as being active users.)
    - Doug: The GSoC proposal needs to have a proposed schedule broken down into milestones
        and we need to give pass/fail marks at the end of each milestone.  How should we
        approach this given the uncertainty in how much time it will take.
    - Larry: We can use our best judgement.  As long as the student is making good progress
        we are able to pass them even if it is not exactly what the milestone proposed.
    - Mark: The core library does not support float pixel types.  Also it is very limited
        in what types of EXR images may be read (e.g. looking for a specific channel layout,
        no multi-part support).
    - Kevin: A quick scan of the EXR codec shows it only really outputs 16 bit RGB, RGBA, YCbCr.
         https://github.com/FFmpeg/FFmpeg/blob/main/libavcodec/exr.c#L1691 
        - Mark: Is that integer 16 bit? 
        - Kevin: Yes, integers.
    - Mark: One approach would be to make video filters for OCIO ColorSpaceTransform and
        OCIO DisplayTransform, similar to the tools in Nuke, etc.

* Documentation
    - Doug: Any updates/thoughts from anyone on efforts to improve the documentation?
    - Carol: I will try to find time to look into wiki options some more.
    - Doug: Should I enable GitHub Wikis on our OCIO site to enable experimentation?
        - Group: Yes.

* GSoC Mentoring
    - Larry: If you are interested in being a GSoC mentor, make sure you sign up.
        - Doug: I may have missed the email.  Note: I found it and signed up.  Thanks Larry!
        - Patrick: I'm already signed up.
    - Doug/Group: Thank you Rashil for joining the meeting today!
