<!-- SPDX-License-Identifier: CC-BY-4.0 -->
<!-- Copyright Contributors to the OpenColorIO Project. -->

September 14, 2020

Host: Michael Dolan

Attendees:
  * [X] Mark Boorer (_TSC_) - Industrial Light & Magic
  * [X] Mei Chu (_TSC_) - Sony Pictures Imageworks
  * [ ] Sean Cooper (_TSC ACES TAC Rep_) - DNEG
  * [X] Michael Dolan (_TSC Chair_) - Epic Games
  * [X] Patrick Hodoul (_TSC_) - Autodesk
  * [ ] John Mertic - Academy Software Foundation / Linux Foundation
  * [X] Carol Payne (_TSC_) - Netflix
  * [X] Mark Titchener (_TSC_) - Foundry
  * [ ] Carl Rand (_TSC_) - Weta Digital
  * [X] Doug Walker (_TSC Chief Architect_) - Autodesk
  * [X] Kevin Wheatley (_TSC_) - Framestore
  * [X] Bernard Lefebvre - Autodesk
  * [X] Alessandra Tomassi - Industrial Light & Magic
  * [X] Matthias Scharfenberg - Industrial Light & Magic
  * [X] J Schulte - Industrial Light & Magic

# **OCIO TSC Meeting Notes**

* Zoom
    - Mark B: Some people having trouble logging into Zoom. Is this meeting 
      open to the public?
    - Michael: Yes it's open to all. I do believe a free Zoom account is 
      needed to login to some Zoom meetings now. Zoom has been making changes
      to improve security. Later in the month joining a meeting will require 
      either a passcode (not to be confused with password) or meetings will
      require a waiting room with a host to let attendees in. We will try to 
      embed the passcode in the meeting URL. If anyone has an issue joining,
      have them reach out to me and I'll help troubleshoot.

* PROCESS.md (PR #1140):
    - Michael: New PROCESS.md document outlines new feature development process 
      for project in response to issue #1124. Please have a look and provide 
      feedback. I attempted to document the current process with expanded 
      detail around design review.
        - Also created a "Roadmap" GH project to track feature proposals. Open 
          for discussion.

* New TSC meeting time and duration:
    - Michael: Continuing previous discussion on merging OCIO v2 working group 
      with the TSC, extending the TSC meeting to 1 hour, and pushing the time 
      back to make accessible for NZ attendees. This makes for a later time for
      London, but makes the time work for all time zones. Propose same time 
      slot used for other ASWF meetings (8am NZST/4pm EST/1pm PDT/9pm BST).
    - Mark B: Would prefer earlier if possible, but can work.
    - Mark T, Kevin: Time works ok.
    - J: Can we rotate meeting between different time slots. Every other 
      meeting early and late. Some other meetings do this and works.
    - Carol: D&I working group does that. Might be an issue for getting quorum 
      though.
    - J: Monday also intersects with many holidays.
    - Kevin: And other days of week don't work well because of other ASWF 
      meetings, etc.
    - Carol: Can push meetings on holidays whe needed.
    - Michael: We will try to reduce cadence once v2 is released, to either 
      bi-weekly or monthly, as needed.
    - Kevin, Mark T: Later is fine if we're meeting less frequently.
    - Doug: Carl Rand, who is a TSC member can't make it due to time. Thomas 
      is an active contributor and testing v2 features also. Should consider 
      something that works for them too. As I wrote in issue #1124, we (AD) 
      second the proposal to merge the working group and TSC.
    - Mark B: Could be longer than an hour. Sometimes v2 working group 
      discussions run over.
    - Carol: Discussions may calm down after release.
    - Kevin: Hope so. With the new cadence and longer time, should amount to 
      similar amount of time. Wont be as many controversial features to 
      discuss.
    - Doug: Hour should be good. Let's start with that.
    - Carol: In terms of transparency, agenda is king. People should have 
      visibility into topics for a meeting ahead of time, which will help 
      inform who want to join the discussion.
    - Michael: Yes, agree. I have not been the best with getting the agenda 
      out early. My intent going forward is to link the ongoing Google doc we
      use for agenda items each week in the calender event for visibility, 
      with a note about adding agenda items ahead of time.

* GH main branch:
    - Michael: Wider discussion happening in GH and ASWF right now about 
      default branch names. GH is moving to "main", and OpenEXR is considering 
      "dev". We should decide our course of action. GitHub recommends waiting 
      a bit before making the move since they will introduce tooling to ease 
      the transition.
    - Doug: Prefer to wait till we branch for v2. Would be an ideal time to do 
      it.
    - Mark B: Disagree with OpenEXR workflow. Prefer "main" over "dev". People 
      should land in a stable branch, which "dev" does not imply. 
    - J: Agree.
    - Mark B: A bit different with CI keeping the branch stable, but good to 
      land on first stable branch ideally.
    - Carol: All for changing the name in due course, but recommend staying 
      with what GH is supporting, so we can utilize their tooling and avoid 
      creating more work for ourselves.
    - Michael: Ok, so we'll plan on switching to "main" when branching for OCIO
      v2 release.

* Help Wanted issue label:
    - Doug: Want to create a label for issues needing help, but that aren't 
      good first issues. Have list of tasks planning to add that are good for 
      people who have some time to contribute but aren't new to the project. 
      Thomas uses a "Help Wanted" label, and other projects use it also. 
    - Michael: Sounds like a good choice.
    - TSC agrees.

* GH Issue subjects vs labels:
    - Kevin: Noticed in some cases that subjects will have notes like "\[RFC\]". 
      Like labels but not. Need some cleanup with labels, with some new ones like 
      "RFC", etc.
    - Carol: Yes. Looking for ways to track stuff for documentation work. I've 
      been using checklists and the project board, etc.
    - Michael: Need new committer level that isn't "Write" but allows adding 
      labels to issue and general admin work.
    - Patrick: I'm doing follow to add labels on issues. Don't want to add 
      labels to all defects, since it's not always clear and we don't want too 
      many, but new labels like "RFC" should be added. Will improve understanding 
      of project to clean up.
    - Doug: Labels can add issues to GH project automatically, which might be 
      worth looking into.
    - J: Can get busted in my experience.
  